#include <iostream>
#include <math.h>
#include <string>
using namespace std;
int main(int argc, char** argv) {
	int a;
	long long int niz[2];
	string zavrsetak;
	cin>>a;
	for(int i=0;i<a;i++){
		int f=0; 
		long long int a1,a2;
		long int n,m;
		cin>>n>>m>>a1>>a2;
		niz[0]=abs(a1-a2);
		for(int j=2;j<n;j++){
			long long int a3;
			cin>>a3;
			niz[1]=abs(a1-a3);
			while(niz[1]!=niz[0]){
					if(niz[0]>niz[1]) niz[0]=niz[0]-niz[1] ; else niz[1]=niz[1]-niz[0];
					
		}
			
		}
		for(int i=0;i<m;i++){
			if(niz[0]==1 ) {
				f=f+1;
			}
			int tr;
			cin>>tr;
			if (abs(a1-tr) % niz[0] == 0 ) {
				f=f+1;
			}
		}
		if(f==0) zavrsetak=zavrsetak + "1"; else zavrsetak=zavrsetak + "0";
	}
	for(int i=0;i<a;i++){
		cout<<zavrsetak[i]<<endl;
	}
	
	return 0;
}